import java.awt.EventQueue;

import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JToggleButton;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.File;
import java.util.List;
import java.awt.Font;
import javax.swing.JTextArea;
import javax.swing.JScrollPane;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

/**
 * Demo App die Teile der Klasse DFController benutzt um einige Daten aus einem Datafox Gert zu lesen 
 * und zu schreiben. 
 * Der Zugriff auf die DLL erfolgt mit JNA.
 * Weitere mgliche Funktionen knnen mit der Hilfedatei der DLL gefunden werden.
 * Weitere Informationen siehe DFController Klasse die wiederum das Interface DFCom nutzt.
 *  
 * @author Harald Kranz
 *
 */
public class DemoDFComApp {

	private JFrame frmDemoDfcom;
	private JTextField txtDLL;
	private JTextField txtIPAdr;
	private JTextField txtPort;
	private JTextField txtDeviceID;
	private JTextField txtChannelID;
	private JCheckBox chkDLLbenutzen;
	private DFController dfController;

	private JTextField txtHead1;
	private JTextField txtHaed2;
	private JTextField txtBoxHead;
	private JTextField txtDisplayTime;
	private JTextField txtSetupFile;
	private JTextField txtListPath;
	
	private JTextArea textAreaBox;
	private JTextField textField;
	private JButton btnSenden;
	private JButton btnLoadData;
	private JButton btnSaveData;
	private JButton btnSaveList;
	private JTextArea textAreaData;
	

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					DemoDFComApp window = new DemoDFComApp();
					window.frmDemoDfcom.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public DemoDFComApp() {
		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		frmDemoDfcom = new JFrame();
		frmDemoDfcom.addWindowListener(new WindowAdapter() {
			@Override
			// Schlieen der Gerteverbindung
			public void windowClosed(WindowEvent e) {
				if (dfController.isConnected())
				   dfController.comClose(); 
			}
		});
		frmDemoDfcom.getContentPane().setFont(new Font("Tahoma", Font.PLAIN, 11));
		frmDemoDfcom.setTitle("Demo DFComDLL mit Java \u00FCber JNA");
		frmDemoDfcom.setBounds(100, 100, 519, 750);
		frmDemoDfcom.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frmDemoDfcom.getContentPane().setLayout(null);
		
		final JToggleButton tglBtnConnect = new JToggleButton("Verbindung herstellen");
		tglBtnConnect.setEnabled(false);
		// Verbindung zu dem Gert aufbauen
		tglBtnConnect.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (tglBtnConnect.isSelected())
				{           		
           			if (createNewDFController())
           			{	
					   tglBtnConnect.setText("Gert verbunden");
					   btnSenden.setEnabled(true);
					   btnLoadData.setEnabled(true);
					   btnSaveList.setEnabled(true);
           			}
                    else
                    {
                       JOptionPane.showMessageDialog(null, "Die Verbindung zu dem Gert konnte nicht hergestellt werden.", "Fehler", JOptionPane.OK_CANCEL_OPTION);	
    				   tglBtnConnect.setSelected(false);
                       tglBtnConnect.setText("Verbindung herstellen");
   					   dfController.comClose();
					   btnSenden.setEnabled(false);
					   btnLoadData.setEnabled(false);
					   btnSaveList.setEnabled(false);

                    }
				} else {
					tglBtnConnect.setText("Verbindung herstellen");
					dfController.comClose();
				    btnSenden.setEnabled(false);
					btnLoadData.setEnabled(false);
					btnSaveList.setEnabled(false);

				}
			}
		});
		tglBtnConnect.setBounds(102, 125, 197, 23);
		frmDemoDfcom.getContentPane().add(tglBtnConnect);
		
		JLabel lblNewLabel = new JLabel("Einstellungen Verbindungsaufbau:");
		lblNewLabel.setFont(new Font("Tahoma", Font.BOLD, 11));
		lblNewLabel.setBounds(8, 55, 227, 14);
		frmDemoDfcom.getContentPane().add(lblNewLabel);
		
		JLabel lblEinstellungDerBenutzten = new JLabel("Einstellung der benutzten DFComDLL:");
		lblEinstellungDerBenutzten.setFont(new Font("Tahoma", Font.BOLD, 11));
		lblEinstellungDerBenutzten.setBounds(10, 11, 283, 14);
		frmDemoDfcom.getContentPane().add(lblEinstellungDerBenutzten);
		
		txtDLL = new JTextField();
		txtDLL.setText("E:\\DFComDLL.dll");
		txtDLL.setBounds(102, 28, 251, 20);
		frmDemoDfcom.getContentPane().add(txtDLL);
		txtDLL.setColumns(10);
		
		final JButton btnDLLFile = new JButton("...");
		// Auswahl der DLL
		btnDLLFile.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (chkDLLbenutzen.isSelected()== false)
				{ 
					JFileChooser fileopen = new JFileChooser();
				    fileopen.setCurrentDirectory(new java.io.File("."));
					FileFilter filter = new FileNameExtensionFilter("DLL Dateien", "dll");
					fileopen.addChoosableFileFilter(filter);

					int ret = fileopen.showDialog(frmDemoDfcom, "bernehmen");

					if (ret == JFileChooser.APPROVE_OPTION) {
						File file = fileopen.getSelectedFile();
						txtDLL.setText(file.getAbsolutePath());
					}
				}
			}
		});
		btnDLLFile.setBounds(354, 27, 41, 23);
		frmDemoDfcom.getContentPane().add(btnDLLFile);
		
		JLabel lblNewLabel_1 = new JLabel("Datei (DLL):");
		lblNewLabel_1.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblNewLabel_1.setBounds(9, 31, 107, 14);
		frmDemoDfcom.getContentPane().add(lblNewLabel_1);
		
		txtIPAdr = new JTextField();
		txtIPAdr.setEditable(false);
		txtIPAdr.setText("192.168.123.34");
		txtIPAdr.setBounds(102, 71, 112, 20);
		frmDemoDfcom.getContentPane().add(txtIPAdr);
		txtIPAdr.setColumns(10);
		
		JLabel lblIpadresse = new JLabel("IP-Adresse:");
		lblIpadresse.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblIpadresse.setBounds(8, 73, 80, 14);
		frmDemoDfcom.getContentPane().add(lblIpadresse);
		
		JLabel lblPort = new JLabel("Port:");
		lblPort.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblPort.setBounds(219, 74, 46, 14);
		frmDemoDfcom.getContentPane().add(lblPort);
		
		txtPort = new JTextField();
		txtPort.setEditable(false);
		txtPort.setText("8000");
		txtPort.setBounds(252, 71, 38, 20);
		frmDemoDfcom.getContentPane().add(txtPort);
		txtPort.setColumns(10);
		
		JLabel lblNewLabel_2 = new JLabel("Ger\u00E4te-ID:");
		lblNewLabel_2.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblNewLabel_2.setBounds(137, 98, 80, 14);
		frmDemoDfcom.getContentPane().add(lblNewLabel_2);
		
		txtDeviceID = new JTextField();
		txtDeviceID.setEditable(false);
		txtDeviceID.setText("254");
		txtDeviceID.setBounds(196, 95, 46, 20);
		frmDemoDfcom.getContentPane().add(txtDeviceID);
		txtDeviceID.setColumns(10);
		
		JLabel lblKanalNr = new JLabel("Kanal Nr.:");
		lblKanalNr.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblKanalNr.setBounds(11, 103, 69, 14);
		frmDemoDfcom.getContentPane().add(lblKanalNr);
		
		txtChannelID = new JTextField();
		txtChannelID.setEditable(false);
		txtChannelID.setText("1");
		txtChannelID.setBounds(102, 95, 30, 20);
		frmDemoDfcom.getContentPane().add(txtChannelID);
		txtChannelID.setColumns(10);
		
		
		chkDLLbenutzen = new JCheckBox("DLL benutzen");
		chkDLLbenutzen.setFont(new Font("Tahoma", Font.PLAIN, 11));
		// Einstellung der DLL als zu verwenden
		chkDLLbenutzen.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (chkDLLbenutzen.isSelected()) {
					tglBtnConnect.setEnabled(true);
					txtChannelID.setEditable(true);
					txtDeviceID.setEditable(true);
					txtIPAdr.setEditable(true);
					txtPort.setEditable(true);
					txtDLL.setEditable(false);
				} else {
					tglBtnConnect.setEnabled(false);					
					txtChannelID.setEditable(false);
					txtDeviceID.setEditable(false);
					txtIPAdr.setEditable(false);
					txtPort.setEditable(false);
					txtDLL.setEditable(true);
				}
			}
		});
		chkDLLbenutzen.setBounds(401, 27, 141, 23);
		frmDemoDfcom.getContentPane().add(chkDLLbenutzen);
		
		JLabel lblSendenVonMessages = new JLabel("Senden von Messages an das Ger\u00E4t:");
		lblSendenVonMessages.setFont(new Font("Tahoma", Font.BOLD, 11));
		lblSendenVonMessages.setBounds(10, 159, 249, 14);
		frmDemoDfcom.getContentPane().add(lblSendenVonMessages);
		
		txtHead1 = new JTextField();
		txtHead1.setBounds(103, 176, 251, 20);
		frmDemoDfcom.getContentPane().add(txtHead1);
		txtHead1.setColumns(10);
		
		JLabel lblKopfzeile = new JLabel("Kopfzeile1:");
		lblKopfzeile.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblKopfzeile.setBounds(10, 179, 107, 14);
		frmDemoDfcom.getContentPane().add(lblKopfzeile);
		
		JLabel lblKopfzeile_1 = new JLabel("Kopfzeile2: ");
		lblKopfzeile_1.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblKopfzeile_1.setBounds(10, 204, 107, 14);
		frmDemoDfcom.getContentPane().add(lblKopfzeile_1);
		
		txtHaed2 = new JTextField();
		txtHaed2.setColumns(10);
		txtHaed2.setBounds(103, 201, 251, 20);
		frmDemoDfcom.getContentPane().add(txtHaed2);
		
		txtBoxHead = new JTextField();
		txtBoxHead.setColumns(10);
		txtBoxHead.setBounds(103, 228, 251, 20);
		frmDemoDfcom.getContentPane().add(txtBoxHead);
		
		JLabel lblBoxenberschrift = new JLabel("Boxen\u00FCberschrift");
		lblBoxenberschrift.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblBoxenberschrift.setBounds(10, 231, 107, 14);
		frmDemoDfcom.getContentPane().add(lblBoxenberschrift);
		
		JLabel lblBoxeninhalt = new JLabel("Boxeninhalt:");
		lblBoxeninhalt.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblBoxeninhalt.setBounds(10, 261, 80, 14);
		frmDemoDfcom.getContentPane().add(lblBoxeninhalt);
		// Senden einer Message an das Gert 
		btnSenden = new JButton("Message Senden");
		btnSenden.setEnabled(false);
		btnSenden.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					if (msgSend())
                       JOptionPane.showMessageDialog(null, "Erfolgreich gesendet.", "Info", JOptionPane.OK_CANCEL_OPTION);	
					else 
                       JOptionPane.showMessageDialog(null, "Nicht gesendet.", "Info", JOptionPane.OK_CANCEL_OPTION);	
						
				} catch (DFError e1) {
                    JOptionPane.showMessageDialog(null, e1.getMessage(), "Fehler", JOptionPane.OK_CANCEL_OPTION);	;
				}
			}
		});
		btnSenden.setBounds(192, 337, 165, 23);
		frmDemoDfcom.getContentPane().add(btnSenden);
		
		JLabel lblAnzeigezeit = new JLabel("Anzeigezeit:");
		lblAnzeigezeit.setBounds(9, 340, 74, 14);
		frmDemoDfcom.getContentPane().add(lblAnzeigezeit);
		
		txtDisplayTime = new JTextField();
		txtDisplayTime.setText("5");
		txtDisplayTime.setBounds(106, 337, 29, 20);
		frmDemoDfcom.getContentPane().add(txtDisplayTime);
		txtDisplayTime.setColumns(10);
		
		JLabel lblLadenDerDatenstze = new JLabel("\u00DCbertragen der Daten aus dem Ger\u00E4t in eine Liste und Speicherung in einer Datei:");
		lblLadenDerDatenstze.setFont(new Font("Tahoma", Font.BOLD, 11));
		lblLadenDerDatenstze.setBounds(12, 365, 489, 14);
		frmDemoDfcom.getContentPane().add(lblLadenDerDatenstze);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(105, 256, 252, 76);
		frmDemoDfcom.getContentPane().add(scrollPane);
		
		textAreaBox = new JTextArea();
		scrollPane.setViewportView(textAreaBox);
		textAreaBox.setRows(4);
		
		btnLoadData = new JButton("\u00DCbertragen in Liste");
		btnLoadData.setEnabled(false);
		btnLoadData.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				getData();
			}
		});
		btnLoadData.setBounds(8, 390, 227, 23);
		frmDemoDfcom.getContentPane().add(btnLoadData);
		
		JLabel lblLadenUndbertragen = new JLabel("\u00DCbertragen der Listendaten mit Setupdatei auf ein Ger\u00E4t:");
		lblLadenUndbertragen.setFont(new Font("Tahoma", Font.BOLD, 11));
		lblLadenUndbertragen.setBounds(9, 511, 376, 14);
		frmDemoDfcom.getContentPane().add(lblLadenUndbertragen);
		
		JLabel lblSetupdatei = new JLabel("Setupdatei:");
		lblSetupdatei.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblSetupdatei.setBounds(8, 539, 107, 14);
		frmDemoDfcom.getContentPane().add(lblSetupdatei);
		
		txtSetupFile = new JTextField();
		txtSetupFile.setText("E:\\DFComDLL.dll");
		txtSetupFile.setColumns(10);
		txtSetupFile.setBounds(130, 536, 203, 20);
		frmDemoDfcom.getContentPane().add(txtSetupFile);
		
		JButton btnSetupFile = new JButton("...");
		btnSetupFile.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				JFileChooser fileopen = new JFileChooser();
			    fileopen.setCurrentDirectory(new java.io.File("."));
				FileFilter filter = new FileNameExtensionFilter("Setup Dateien", "aes");
				fileopen.addChoosableFileFilter(filter);

				int ret = fileopen.showDialog(frmDemoDfcom, "bernehmen");

				if (ret == JFileChooser.APPROVE_OPTION) {
					File file = fileopen.getSelectedFile();
					txtSetupFile.setText(file.getAbsolutePath());
				}
			}
		});
		btnSetupFile.setBounds(343, 536, 41, 23);
		frmDemoDfcom.getContentPane().add(btnSetupFile);
		
		JLabel lblListenverzeichnis = new JLabel("Listenverzeichnis:");
		lblListenverzeichnis.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblListenverzeichnis.setBounds(8, 570, 107, 14);
		frmDemoDfcom.getContentPane().add(lblListenverzeichnis);
		
		txtListPath = new JTextField();
		txtListPath.setText("E:\\DFComDLL.dll");
		txtListPath.setColumns(10);
		txtListPath.setBounds(130, 567, 203, 20);
		frmDemoDfcom.getContentPane().add(txtListPath);
		
		JButton btnListPath = new JButton("...");
		btnListPath.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				
				JFileChooser chooser = new JFileChooser(); 
			    chooser.setCurrentDirectory(new java.io.File("."));
			    chooser.setDialogTitle("Verzeichnisauswahl");
			    chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				int ret = chooser.showDialog(frmDemoDfcom, "bernehmen");

				if (ret == JFileChooser.APPROVE_OPTION) {
					File file = chooser.getSelectedFile();
					txtListPath.setText(file.getAbsolutePath());
				}
			}
		});
		btnListPath.setBounds(343, 565, 41, 23);
		frmDemoDfcom.getContentPane().add(btnListPath);
		
		btnSaveList = new JButton("\u00DCbertragen auf Ger\u00E4t");
		btnSaveList.setEnabled(false);
		btnSaveList.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
			}
		});
		btnSaveList.setBounds(195, 598, 189, 23);
		frmDemoDfcom.getContentPane().add(btnSaveList);
		
		JScrollPane scrollPane_1 = new JScrollPane();
		scrollPane_1.setBounds(8, 424, 493, 76);
		frmDemoDfcom.getContentPane().add(scrollPane_1);
		
		textAreaData = new JTextArea();
		textAreaData.setRows(4);
		scrollPane_1.setViewportView(textAreaData);
		
		btnSaveData = new JButton("Speicherung der Liste");
		btnSaveData.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
			}
		});
		btnSaveData.setEnabled(false);
		btnSaveData.setBounds(274, 390, 227, 23);
		frmDemoDfcom.getContentPane().add(btnSaveData);
		
		JLabel lblProgrammstatusanzeige = new JLabel("Programmstatusanzeige:");
		lblProgrammstatusanzeige.setFont(new Font("Tahoma", Font.BOLD, 11));
		lblProgrammstatusanzeige.setBounds(8, 648, 376, 14);
		frmDemoDfcom.getContentPane().add(lblProgrammstatusanzeige);
		
		textField = new JTextField();
		textField.setEditable(false);
		textField.setColumns(10);
		textField.setBounds(8, 666, 493, 20);
		frmDemoDfcom.getContentPane().add(textField);
	}
	
	/**
	 * Neuen Controller Erstellen um eine Verbindung zu dem Gert aufzubauen
	 * 
	 * @return true wenn erfolgreich
	 */
	private boolean createNewDFController()
	{
    	int devID = Integer.parseInt(txtDeviceID.getText());
		int channelID = Integer.parseInt(txtChannelID.getText());
		int port = Integer.parseInt(txtPort.getText());
		
		dfController = new DFController(txtDLL.getText(),channelID,devID);
	    dfController.comOpen(txtIPAdr.getText(),port);
	    return dfController.isConnected();
	}
	
	/**
	 * Senden einer Nachricht an das Gert zu dem eine Verbindung aufgebaut wurde.
	 * @return true wenn erfolgreich 
	 * @throws DFError mgliche Fehler werden weitergeleitet.
	 */
	private boolean msgSend() throws DFError
	{
		System.out.println(dfController.isConnected());
		String message = txtHead1.getText() +"\r"+txtHaed2.getText()+"\r"+txtBoxHead.getText()+"\r"+ textAreaBox.getText();
		message = message.replace("\n", "\r");
		int displayTime = Integer.parseInt(txtDisplayTime.getText());

		if (dfController.sendMessage(message,displayTime)== 1) 
			return true;
		else 
			return false;
	}
	
	private boolean getData() 
	{
		try {
			List<DFRecord> listRec = dfController.readAllRecords();
			if (listRec!= null)
			{
				for (int i = 0;i < listRec.size();i++)
				{
					textAreaData.append(listRec.get(i).getStringValue()+"\n");
				}
			}
		} catch (DFError e) {
			System.out.println(e.getMessage());
		}
		return true;
	}
	
}
