/*!
    \file   df_lists.h
    \author Bernd Ottmann
    \date   21.02.2003
    \brief  Deklarationen der Funktionen für den Zugriff auf enthaltene Listen und deren Veränderung.
*/
#ifndef DF_LISTS_H
#define DF_LISTS_H

#include "df_defines.h"

#if (DF_API_VERSION >= 0x04010100)
DF_API_EXTERN int DF_API_CALL DFCOpenTable( int connectionId, int deviceAddress, char *name, int options, int *tableHandle, char *reserved, int *errorNumber );
DF_API_EXTERN int DF_API_CALL DFCCloseTable( int connectionId, int deviceAddress, int tableHandle, int *errorNumber );
DF_API_EXTERN int DF_API_CALL DFCSetFilter( int connectionId, int deviceAddress, int tableHandle, char *value, int *errorNumber );
DF_API_EXTERN int DF_API_CALL DFCGetFilter( int connectionId, int deviceAddress, int tableHandle, char *value, int *valueLength, int *errorNumber );
DF_API_EXTERN int DF_API_CALL DFCClearFilter( int connectionId, int deviceAddress, int tableHandle, int *errorNumber );
DF_API_EXTERN int DF_API_CALL DFCSkip( int connectionId, int deviceAddress, int tableHandle, int offset, int origin, int *errorNumber );
DF_API_EXTERN int DF_API_CALL DFCSetField( int connectionId, int deviceAddress, int tableHandle, char *name, char *value, int *errorNumber );
DF_API_EXTERN int DF_API_CALL DFCGetField( int connectionId, int deviceAddress, int tableHandle, char *name, char *value, int *valueLength, int *errorNumber );
#endif

#endif
